/*   
 *   $Id: debts.h,v 1.12 2001/08/26 12:22:29 ondra Exp $
 * 
 *   Holiday Debts manager for PalmOS.
 *   Copyright (C) 2000,2001 Ondrej Palkovsky
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 * 
 *   You can contact me at 'ondrap@penguin.cz'.
*/

#ifndef _DEBTS_H_
#define _DEBTS_H_

#include "db.h"

#define APP_ID 'OpDt'
#define PREF_DEFAULT 1
#define PREF_VERSION 5

typedef enum {
    TOTALCOST=0,
    USERCOST=1,
    USERPAYMENT=2,
    USERBALANCE=3,
    INTERCOST=4
}CostMode;

typedef struct {
    enum {
	pref_dbmgr,
	pref_main
    }start;
    LocalID dbid;
    UInt16 cardno;
    char lcurrency[MAX_CURRENCY_NAME+1];
    Boolean activeBalance;
}PrefData;

void *  GetObjectPtr(UInt16 objectID);
double get_item_costs(itemType *item,Int16 user,CostMode mode,Int16 currency);
void debts_save_dbmgr(void);
void debts_save_main(LocalID dbid,UInt16 cardno);

extern DateFormatType dateFormat;
extern DateFormatType longDateFormat;
extern Boolean palmOS31;
extern char defaultCurrency[MAX_CURRENCY_NAME+1];
extern Boolean activeBalance;
#endif
